using System;
using System.Collections;

namespace Chat.Controlador
{
	/// <summary>
	/// Descripcin breve de IChatClient.
	/// </summary>
	public interface IChatClient
	{
		void crearCanal(string nom_canal);
		void esborrarCanal(string nom_canal);
		ArrayList getCanals();
		ArrayList getUsuarisCanal(string nom_canal);
		bool entrar(string nick, string nom_canal);
		bool sortir(string nick, string nom_canal);
		bool enviarMissatge(string nick, string nom_canal, string missatge);
	}
}
