using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Chat.Controlador;
using Chat.Remoting;

namespace Chat.VistaClient
{
	/// <summary>
	/// Descripcin breve de Form1.
	/// </summary>
	public class FormVistaClient : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox textBoxRemotingConfig;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox textBoxNick;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Button buttonConnectar;
		private System.Windows.Forms.ListBox listBoxCanals;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Button buttonEntrar;
		private System.Windows.Forms.Label labelCanalActual;
		private System.Windows.Forms.TextBox textBoxMissatge;
		private System.Windows.Forms.Button buttonEnviar;
		private System.Windows.Forms.TextBox textBoxMissatgesCanal;
		private System.Windows.Forms.TextBox textBoxCanal;
		private System.Windows.Forms.Button buttonSortir;
		private ChatClientFacade chatClientFacade;
		private VistaListeners vistaListeners;
		private VistaObserver vistaObserver;
		private string nick;
		private string canalActual;
		private System.Windows.Forms.ListBox listBoxUsuaris;
		
		/// <summary>
		/// Variable del diseador requerida.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FormVistaClient()
		{
			//
			// Necesario para admitir el Diseador de Windows Forms
			//
			InitializeComponent();

			//
			// TODO: agregar cdigo de constructor despus de llamar a InitializeComponent
			//
		}

		/// <summary>
		/// Limpiar los recursos que se estn utilizando.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Cdigo generado por el Diseador de Windows Forms
		/// <summary>
		/// Mtodo necesario para admitir el Diseador. No se puede modificar
		/// el contenido del mtodo con el editor de cdigo.
		/// </summary>
		private void InitializeComponent()
		{
			this.textBoxRemotingConfig = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.textBoxNick = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.buttonConnectar = new System.Windows.Forms.Button();
			this.listBoxCanals = new System.Windows.Forms.ListBox();
			this.label4 = new System.Windows.Forms.Label();
			this.buttonEntrar = new System.Windows.Forms.Button();
			this.textBoxMissatgesCanal = new System.Windows.Forms.TextBox();
			this.labelCanalActual = new System.Windows.Forms.Label();
			this.textBoxMissatge = new System.Windows.Forms.TextBox();
			this.buttonEnviar = new System.Windows.Forms.Button();
			this.textBoxCanal = new System.Windows.Forms.TextBox();
			this.buttonSortir = new System.Windows.Forms.Button();
			this.listBoxUsuaris = new System.Windows.Forms.ListBox();
			this.SuspendLayout();
			// 
			// textBoxRemotingConfig
			// 
			this.textBoxRemotingConfig.Location = new System.Drawing.Point(160, 32);
			this.textBoxRemotingConfig.Name = "textBoxRemotingConfig";
			this.textBoxRemotingConfig.Size = new System.Drawing.Size(136, 20);
			this.textBoxRemotingConfig.TabIndex = 1;
			this.textBoxRemotingConfig.Text = "../../RemotingClient.config";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(160, 8);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(136, 23);
			this.label2.TabIndex = 3;
			this.label2.Text = "Configuracio Remoting:";
			// 
			// textBoxNick
			// 
			this.textBoxNick.Location = new System.Drawing.Point(312, 32);
			this.textBoxNick.Name = "textBoxNick";
			this.textBoxNick.TabIndex = 4;
			this.textBoxNick.Text = "";
			this.textBoxNick.TextChanged += new System.EventHandler(this.textBoxNick_TextChanged);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(312, 8);
			this.label3.Name = "label3";
			this.label3.TabIndex = 5;
			this.label3.Text = "Nick:";
			// 
			// buttonConnectar
			// 
			this.buttonConnectar.Enabled = false;
			this.buttonConnectar.Location = new System.Drawing.Point(440, 8);
			this.buttonConnectar.Name = "buttonConnectar";
			this.buttonConnectar.TabIndex = 6;
			this.buttonConnectar.Text = "Connectar";
			this.buttonConnectar.Click += new System.EventHandler(this.buttonConnectar_Click);
			// 
			// listBoxCanals
			// 
			this.listBoxCanals.Location = new System.Drawing.Point(16, 96);
			this.listBoxCanals.Name = "listBoxCanals";
			this.listBoxCanals.Size = new System.Drawing.Size(120, 108);
			this.listBoxCanals.TabIndex = 7;
			this.listBoxCanals.SelectedIndexChanged += new System.EventHandler(this.listBoxCanals_SelectedIndexChanged);
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 72);
			this.label4.Name = "label4";
			this.label4.TabIndex = 8;
			this.label4.Text = "Canals:";
			// 
			// buttonEntrar
			// 
			this.buttonEntrar.Enabled = false;
			this.buttonEntrar.Location = new System.Drawing.Point(40, 240);
			this.buttonEntrar.Name = "buttonEntrar";
			this.buttonEntrar.TabIndex = 9;
			this.buttonEntrar.Text = "Entrar";
			this.buttonEntrar.Click += new System.EventHandler(this.buttonEntrar_Click);
			// 
			// textBoxMissatgesCanal
			// 
			this.textBoxMissatgesCanal.Enabled = false;
			this.textBoxMissatgesCanal.Location = new System.Drawing.Point(152, 96);
			this.textBoxMissatgesCanal.Multiline = true;
			this.textBoxMissatgesCanal.Name = "textBoxMissatgesCanal";
			this.textBoxMissatgesCanal.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.textBoxMissatgesCanal.Size = new System.Drawing.Size(376, 136);
			this.textBoxMissatgesCanal.TabIndex = 10;
			this.textBoxMissatgesCanal.Text = "";
			// 
			// labelCanalActual
			// 
			this.labelCanalActual.Location = new System.Drawing.Point(160, 72);
			this.labelCanalActual.Name = "labelCanalActual";
			this.labelCanalActual.Size = new System.Drawing.Size(360, 23);
			this.labelCanalActual.TabIndex = 11;
			this.labelCanalActual.Text = "No Connectat";
			// 
			// textBoxMissatge
			// 
			this.textBoxMissatge.Enabled = false;
			this.textBoxMissatge.Location = new System.Drawing.Point(152, 240);
			this.textBoxMissatge.Name = "textBoxMissatge";
			this.textBoxMissatge.Size = new System.Drawing.Size(288, 20);
			this.textBoxMissatge.TabIndex = 12;
			this.textBoxMissatge.Text = "";
			this.textBoxMissatge.TextChanged += new System.EventHandler(this.textBoxMissatge_TextChanged);
			// 
			// buttonEnviar
			// 
			this.buttonEnviar.Enabled = false;
			this.buttonEnviar.Location = new System.Drawing.Point(448, 240);
			this.buttonEnviar.Name = "buttonEnviar";
			this.buttonEnviar.TabIndex = 13;
			this.buttonEnviar.Text = "Enviar";
			this.buttonEnviar.Click += new System.EventHandler(this.buttonEnviar_Click);
			// 
			// textBoxCanal
			// 
			this.textBoxCanal.Location = new System.Drawing.Point(16, 208);
			this.textBoxCanal.Name = "textBoxCanal";
			this.textBoxCanal.Size = new System.Drawing.Size(120, 20);
			this.textBoxCanal.TabIndex = 14;
			this.textBoxCanal.Text = "";
			this.textBoxCanal.TextChanged += new System.EventHandler(this.textBoxCanal_TextChanged);
			// 
			// buttonSortir
			// 
			this.buttonSortir.Location = new System.Drawing.Point(440, 32);
			this.buttonSortir.Name = "buttonSortir";
			this.buttonSortir.TabIndex = 15;
			this.buttonSortir.Text = "Sortir";
			this.buttonSortir.Click += new System.EventHandler(this.buttonSortir_Click);
			// 
			// listBoxUsuaris
			// 
			this.listBoxUsuaris.Enabled = false;
			this.listBoxUsuaris.Location = new System.Drawing.Point(536, 96);
			this.listBoxUsuaris.Name = "listBoxUsuaris";
			this.listBoxUsuaris.Size = new System.Drawing.Size(120, 134);
			this.listBoxUsuaris.TabIndex = 16;
			// 
			// FormVistaClient
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(672, 278);
			this.Controls.Add(this.listBoxUsuaris);
			this.Controls.Add(this.buttonSortir);
			this.Controls.Add(this.textBoxCanal);
			this.Controls.Add(this.textBoxMissatge);
			this.Controls.Add(this.textBoxMissatgesCanal);
			this.Controls.Add(this.textBoxNick);
			this.Controls.Add(this.textBoxRemotingConfig);
			this.Controls.Add(this.buttonEnviar);
			this.Controls.Add(this.labelCanalActual);
			this.Controls.Add(this.buttonEntrar);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.listBoxCanals);
			this.Controls.Add(this.buttonConnectar);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Name = "FormVistaClient";
			this.Text = "Vista Client";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Punto de entrada principal de la aplicacin.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new FormVistaClient());
		}

		//////////////
		// A continuaci es defineixen metodes per actualitzar la UI, des d'un altre thread (e.g. des d'un event)
		//////////////
		private delegate void ChatEventsHandler(object sender, ChatEventArgs e);

		//////////////
		/// Escriure Missatge
		//////////////
		// S'executa fora del thread de la UI
		public void escriureMissatge(string missatge) 
		{
			// Wrap the parameters in some EventArgs-derived custom class:
			object[] pList = { this, new ChatEventArgs(null, missatge, null) };
 
			// Invoke the method. This class is derived
			// from Form, so we can just call BeginInvoke
			// to get to the UI thread.
			BeginInvoke(new ChatEventsHandler(escriureMissatgeUI), pList);
		}
 
		// S'executa al thread de la UI
		private void escriureMissatgeUI(object sender, ChatEventArgs e) 
		{
			this.textBoxMissatgesCanal.Text = this.textBoxMissatgesCanal.Text + "\r\n" + e.Missatge;
		}

		//////////////
		/// Afegir Canal
		//////////////
		// S'executa fora del thread de la UI
		public void afegirCanal(string canal) 
		{
			// Wrap the parameters in some EventArgs-derived custom class:
			object[] pList = { this, new ChatEventArgs(canal) };
 
			// Invoke the method. This class is derived
			// from Form, so we can just call BeginInvoke
			// to get to the UI thread.
			BeginInvoke(new ChatEventsHandler(afegirCanalUI), pList);
		}
 
		// S'executa al thread de la UI
		private void afegirCanalUI(object sender, ChatEventArgs e) 
		{
			this.listBoxCanals.Items.Add(e.Canal);
		}


		//////////////
		/// Esborrar Canal
		//////////////
		// S'executa fora del thread de la UI
		public void esborrarCanal(string canal) 
		{
			// Wrap the parameters in some EventArgs-derived custom class:
			object[] pList = { this, new ChatEventArgs(canal) };
 
			// Invoke the method. This class is derived
			// from Form, so we can just call BeginInvoke
			// to get to the UI thread.
			BeginInvoke(new ChatEventsHandler(esborrarCanalUI), pList);
		}
 
		// S'executa al thread de la UI
		private void esborrarCanalUI(object sender, ChatEventArgs e) 
		{
			this.listBoxCanals.Items.Remove(e.Canal);
		}

		//////////////
		/// Afegir usuari
		//////////////
		// S'executa fora del thread de la UI
		public void afegirUsuari(string usuari) 
		{
			// Wrap the parameters in some EventArgs-derived custom class:
			object[] pList = { this, new ChatEventArgs(usuari, null) };
 
			// Invoke the method. This class is derived
			// from Form, so we can just call BeginInvoke
			// to get to the UI thread.
			BeginInvoke(new ChatEventsHandler(afegirUsuariUI), pList);
		}
 
		// S'executa al thread de la UI
		private void afegirUsuariUI(object sender, ChatEventArgs e) 
		{
			this.listBoxUsuaris.Items.Add(e.Nick);
		}

		//////////////
		/// Esborrar usuari
		//////////////
		// S'executa fora del thread de la UI
		public void esborrarUsuari(string usuari) 
		{
			// Wrap the parameters in some EventArgs-derived custom class:
			object[] pList = { this, new ChatEventArgs(usuari, null) };
 
			// Invoke the method. This class is derived
			// from Form, so we can just call BeginInvoke
			// to get to the UI thread.
			BeginInvoke(new ChatEventsHandler(esborrarUsuariUI), pList);
		}
 
		// S'executa al thread de la UI
		private void esborrarUsuariUI(object sender, ChatEventArgs e) 
		{
			this.listBoxUsuaris.Items.Remove(e.Nick);
		}

		private void buttonSortir_Click(object sender, System.EventArgs e)
		{
			if (canalActual != null) 
			{
				// Sortim
				chatClientFacade.sendCommand(new ChatClientCommand(TipusAccio.Sortir, nick, canalActual));

				// Comprovem quants usuaris queden al canal que abandonem, si es 0, l'esborrem
				ArrayList usuarisAnticCanal = chatClientFacade.sendCommand(new ChatClientCommand(TipusAccio.ObtenirUsuarisCanal, nick, canalActual));
				if (usuarisAnticCanal.Count == 0) 
				{
					chatClientFacade.sendCommand(new ChatClientCommand(TipusAccio.EsborrarCanal, nick, canalActual));
				}
			}
			Application.Exit();
		}

		private void buttonConnectar_Click(object sender, System.EventArgs e)
		{
			buttonConnectar.Enabled = false;
			// ChatSubject es singleton
			vistaListeners = new VistaListeners();	// Modificara el ChatSubject
			vistaObserver = new VistaObserver(this);	// Consultara el ChatSubject
			IChatFactory chatFactory = new RemotingChatFactory(this.textBoxRemotingConfig.Text, vistaListeners);
			chatClientFacade = new ChatClientFacade(chatFactory);
			vistaObserver.Nick = textBoxNick.Text;
			this.nick = textBoxNick.Text;
			
			ArrayList canals = chatClientFacade.sendCommand(new ChatClientCommand(TipusAccio.ObtenirCanals));
			foreach(string canal in canals) 
			{
				listBoxCanals.Items.Add(canal);
			}
			labelCanalActual.Text = "Connectat al servidor pero a cap canal.";
		}

		private void textBoxNick_TextChanged(object sender, System.EventArgs e)
		{
			if (textBoxNick.Text.CompareTo("") == 0) 
			{
				buttonConnectar.Enabled = false;
			} 
			else 
			{
				buttonConnectar.Enabled = true;
			}
		}

		private void listBoxCanals_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			
			textBoxCanal.Text = listBoxCanals.Items[listBoxCanals.SelectedIndex].ToString();
		}

		private void textBoxCanal_TextChanged(object sender, System.EventArgs e)
		{
			if (textBoxCanal.Text.CompareTo("") == 0) 
			{
				buttonEntrar.Enabled = false;
			} 
			else 
			{
				buttonEntrar.Enabled = true;
			}
		}

		private void buttonEntrar_Click(object sender, System.EventArgs e)
		{
			bool crearCanal = true;

			// Si el nom del canal al que es vol entrar, es igual al canal en el que ja estem, no fem res
			if ((canalActual != null) && (canalActual.CompareTo(textBoxCanal.Text) == 0)) {
				return;
			}
			
			if (canalActual != null) 
			{
				// Sortim
				chatClientFacade.sendCommand(new ChatClientCommand(TipusAccio.Sortir, nick, canalActual));

				// Comprovem quants usuaris queden al canal que abandonem, si es 0, l'esborrem
				ArrayList usuarisAnticCanal = chatClientFacade.sendCommand(new ChatClientCommand(TipusAccio.ObtenirUsuarisCanal, nick, canalActual));
				if (usuarisAnticCanal.Count == 0) 
				{
					chatClientFacade.sendCommand(new ChatClientCommand(TipusAccio.EsborrarCanal, nick, canalActual));
				}
			}

			// Comprovem si el canal al que volem entrar ja existia
			ArrayList canals = chatClientFacade.sendCommand(new ChatClientCommand(TipusAccio.ObtenirCanals));
			foreach(string canal in canals) 
			{
				if (canal.CompareTo(textBoxCanal.Text) == 0) 
				{
					crearCanal = false;
				}
			}

			// Si no existia, el creem
			if (crearCanal) 
			{
				chatClientFacade.sendCommand(new ChatClientCommand(TipusAccio.CrearCanal, nick, textBoxCanal.Text));
			}
			// Entrem al canal
			chatClientFacade.sendCommand(new ChatClientCommand(TipusAccio.Entrar, nick, textBoxCanal.Text));

			this.textBoxMissatgesCanal.Text = "";
			this.canalActual = textBoxCanal.Text;
			vistaObserver.Canal = textBoxCanal.Text;
			labelCanalActual.Text = "Connectat al canal " + textBoxCanal.Text;
			textBoxMissatge.Enabled = true;

			// Reset del llistat d'usuaris de pantalla
			ArrayList usuarisAEsborrar = new ArrayList();
			foreach (object usuari in listBoxUsuaris.Items) 
			{
				usuarisAEsborrar.Add(usuari);
			}
			foreach (object usuari in usuarisAEsborrar) 
			{
				 listBoxUsuaris.Items.Remove(usuari);
			}

			// Afegim els usuaris al llistat de pantalla
			ArrayList usuaris = chatClientFacade.sendCommand(new ChatClientCommand(TipusAccio.ObtenirUsuarisCanal, nick, canalActual));
			foreach(string usuari in usuaris) 
			{
				listBoxUsuaris.Items.Add(usuari);
			}
		}

		private void textBoxMissatge_TextChanged(object sender, System.EventArgs e)
		{
			if (textBoxMissatge.Text.CompareTo("") == 0) 
			{
				buttonEnviar.Enabled = false;
			}
			else 
			{
				buttonEnviar.Enabled = true;
			}
		}

		private void buttonEnviar_Click(object sender, System.EventArgs e)
		{
			chatClientFacade.sendCommand(new ChatClientCommand(TipusAccio.NouMissatge, nick, textBoxMissatge.Text, canalActual));
			textBoxMissatge.Text = "";
		}
	}
}
