using System;
using System.Collections;

namespace Chat.Model
{
	/// <summary>
	/// Descripcin breve de DadesCanal.
	/// </summary>
	public class DadesCanal
	{
		
		private ArrayList usuaris;
		private string nom;
		
		public string Nom
		{
			get 
			{
				return this.nom;
			}
		}

		public DadesCanal(string nom)
		{
			this.usuaris = new ArrayList();
			this.nom = nom;
		}

		public void afegirUsuari(string nick)
		{
			if(!usuaris.Contains(nick)) 
			{
				usuaris.Add(nick);
			} 
			else 
			{
				throw new Exception("L'usuari ja existeix");
			}
		}

		public void esborrarUsuari(string nick)
		{
			if(!usuaris.Contains(nick)) 
			{
				throw new Exception("L'usuari ja existeix");
			} 
			else 
			{
				usuaris.Remove(nick);
			}
		}

		public ArrayList getUsuaris()
		{
			return usuaris;
		}

		public bool existeixUsuari(string nick)
		{
			if(usuaris.Contains(nick)) 
			{
				return true;
			} 
			else 
			{
				return false;
			}
		}

		
	}
}
