using System;
using Chat.Controlador;

namespace Chat.Remoting
{

	/// <summary>
	/// Descripcin breve de ChatEventArgs.
	/// </summary>
	[Serializable]
	public class ChatEventArgs : EventArgs
	{
		private string nick;
		private string missatge;
		private TipusAccio accio;
		private string canal;

		public ChatEventArgs(TipusAccio accio, string nick, string missatge, string canal) 
		{
			this.accio = accio;
			this.nick = nick;
			this.missatge = missatge;
			this.canal = canal;
		}

		public TipusAccio Accio
		{
			get 
			{
				return this.accio;
			}
		}

		public string Nick
		{
			get 
			{
				return this.nick;
			}
		}

		public string Missatge
		{
			get 
			{
				return this.missatge;
			}
		}

		public string Canal
		{
			get 
			{
				return this.canal;
			}
		}
	}
}
