using System;

namespace Chat.VistaClient
{

	/// <summary>
	/// Descripcin breve de ChatEventArgs.
	/// </summary>
	public class ChatEventArgs : EventArgs
	{
		private string nick;
		private string missatge;
		private string canal;

		public ChatEventArgs(string canal) 
		{
			this.canal = canal;
		}
		public ChatEventArgs(string nick, string canal) 
		{
			this.nick = nick;
			this.canal = canal;
		}
		public ChatEventArgs(string nick, string missatge, string canal) 
		{
			this.nick = nick;
			this.missatge = missatge;
			this.canal = canal;
		}

		public string Nick
		{
			get 
			{
				return this.nick;
			}
		}

		public string Missatge
		{
			get 
			{
				return this.missatge;
			}
		}

		public string Canal
		{
			get 
			{
				return this.canal;
			}
		}
	}
}
