using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Chat.Controlador;
using Chat.Remoting;

namespace Chat.VistaServidor
{
	/// <summary>
	/// Descripcin breve de Form1.
	/// </summary>
	public class FormServidor : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label labelEstat;
		private System.Windows.Forms.Button buttonEscoltar;
		private System.Windows.Forms.Button buttonSortir;
		private IChatServer chatServer;
		private System.Windows.Forms.TextBox textBoxFitxer;
		/// <summary>
		/// Variable del diseador requerida.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FormServidor()
		{
			//
			// Necesario para admitir el Diseador de Windows Forms
			//
			InitializeComponent();

			//
			// TODO: agregar cdigo de constructor despus de llamar a InitializeComponent
			//
		}

		/// <summary>
		/// Limpiar los recursos que se estn utilizando.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Cdigo generado por el Diseador de Windows Forms
		/// <summary>
		/// Mtodo necesario para admitir el Diseador. No se puede modificar
		/// el contenido del mtodo con el editor de cdigo.
		/// </summary>
		private void InitializeComponent()
		{
			this.labelEstat = new System.Windows.Forms.Label();
			this.buttonEscoltar = new System.Windows.Forms.Button();
			this.buttonSortir = new System.Windows.Forms.Button();
			this.textBoxFitxer = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// labelEstat
			// 
			this.labelEstat.Location = new System.Drawing.Point(48, 24);
			this.labelEstat.Name = "labelEstat";
			this.labelEstat.Size = new System.Drawing.Size(120, 24);
			this.labelEstat.TabIndex = 0;
			this.labelEstat.Text = "Estat: OFF";
			// 
			// buttonEscoltar
			// 
			this.buttonEscoltar.Location = new System.Drawing.Point(64, 96);
			this.buttonEscoltar.Name = "buttonEscoltar";
			this.buttonEscoltar.TabIndex = 1;
			this.buttonEscoltar.Text = "Escoltar";
			this.buttonEscoltar.Click += new System.EventHandler(this.buttonEscoltar_Click);
			// 
			// buttonSortir
			// 
			this.buttonSortir.Location = new System.Drawing.Point(64, 120);
			this.buttonSortir.Name = "buttonSortir";
			this.buttonSortir.TabIndex = 2;
			this.buttonSortir.Text = "Sortir";
			this.buttonSortir.Click += new System.EventHandler(this.buttonSortir_Click);
			// 
			// textBoxFitxer
			// 
			this.textBoxFitxer.Location = new System.Drawing.Point(24, 64);
			this.textBoxFitxer.Name = "textBoxFitxer";
			this.textBoxFitxer.Size = new System.Drawing.Size(160, 20);
			this.textBoxFitxer.TabIndex = 3;
			this.textBoxFitxer.Text = "../../RemotingServer.config";
			// 
			// FormServidor
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(200, 166);
			this.Controls.Add(this.textBoxFitxer);
			this.Controls.Add(this.buttonSortir);
			this.Controls.Add(this.buttonEscoltar);
			this.Controls.Add(this.labelEstat);
			this.Name = "FormServidor";
			this.Text = "Vista Servidor";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Punto de entrada principal de la aplicacin.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new FormServidor());
		}

		private void buttonEscoltar_Click(object sender, System.EventArgs e)
		{
			this.labelEstat.Text = "Estat: escoltant...";
			this.buttonEscoltar.Enabled = false;
			IChatFactory chatFactory = new RemotingChatFactory(this.textBoxFitxer.Text, null);
			this.chatServer = chatFactory.crearChatServer();
			this.chatServer.iniciarServer();
		}

		private void buttonSortir_Click(object sender, System.EventArgs e)
		{
			Application.Exit();
		}
	}
}
